"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupOfPropertiesBuilder = void 0;
class GroupOfPropertiesBuilder {
    constructor(propertyGroup, bindPropertyGroup) {
        this.propertyGroup = propertyGroup;
        this.bindPropertyGroup = bindPropertyGroup;
    }
    template(propertiesOfGroup, ...rulesDefintions) {
        return (id, index, siblingAccess) => {
            const group = this.propertyGroup(id, propertiesOfGroup(suffix => `${id}_${suffix}`, index, siblingAccess));
            this.bind(group, ...rulesDefintions);
            return group;
        };
    }
    of(id, propertiesOfGroup, ...rulesDefintions) {
        const group = this.propertyGroup(id, propertiesOfGroup);
        this.bind(group, ...rulesDefintions);
        return group;
    }
    bind(prop, ...rulesDefintions) {
        const builder = this.bindPropertyGroup(prop);
        rulesDefintions.forEach(def => def.buildRules(builder));
    }
}
exports.GroupOfPropertiesBuilder = GroupOfPropertiesBuilder;
