import { AbstractProperty } from "../../properties/abstract-property";
import { GroupOfProperties, PropertyGroup, PropertyGroupData } from "../../properties/group-of-properties";
import { GroupOfPropertiesImpl } from "../../properties/group-of-properties-impl";
import { GroupOfPropertiesValidator } from "../../validators/property-validator";
import { CrossValidationResult } from "../../validators/cross-validation-result";
import { PropertyDependencyOptions } from "../../dependency-graph/property-dependency";
import { AsyncGroupOfPropertiesValidator } from "../../validators/async-property-validator";
import { TextInterpreter, TextInterpreterFcn } from "../../util/text-interpreter/text-interpreter";
import { ValidationMessage } from "../../validators/validation-message";
import { AbstractPropertyRuleBuilder } from "./abstract-property-rule-builder-impl";
export declare class GroupOfPropertiesRuleBuilder<T extends PropertyGroup> extends AbstractPropertyRuleBuilder<PropertyGroupData<T>, GroupOfPropertiesImpl<T>> {
    constructor(property: GroupOfProperties<T>, addDependencies: (from: readonly AbstractProperty[], to: AbstractProperty, options: PropertyDependencyOptions) => void, textInterpreters: {
        [textInterpreter in TextInterpreter]?: TextInterpreterFcn;
    });
    addValidator<Dependencies extends readonly AbstractProperty[]>(...dependencies: Dependencies): (validator: GroupOfPropertiesValidator<T, Dependencies>) => GroupOfPropertiesRuleBuilder<T>;
    addAsyncValidator<Dependencies extends readonly AbstractProperty[]>(...dependencies: Dependencies): (validator: AsyncGroupOfPropertiesValidator<T, Dependencies>) => GroupOfPropertiesRuleBuilder<T>;
    addCrossValidator(validator: (group: T) => CrossValidationResult | Promise<CrossValidationResult>): GroupOfPropertiesRuleBuilder<T>;
    defineVisibleIfAllMembersVisible(): void;
    defineValidIfAllMembersValid(message: (invalidChildren: AbstractProperty[]) => ValidationMessage): void;
}
