"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GroupOfPropertiesRuleBuilder = void 0;
const abstract_property_rule_builder_impl_1 = require("./abstract-property-rule-builder-impl");
class GroupOfPropertiesRuleBuilder extends abstract_property_rule_builder_impl_1.AbstractPropertyRuleBuilder {
    constructor(property, addDependencies, textInterpreters) {
        super(property, addDependencies, textInterpreters);
    }
    addValidator(...dependencies) {
        return this.addValidatorInternal(...dependencies);
    }
    addAsyncValidator(...dependencies) {
        return this.addAsyncValidatorInternal(...dependencies);
    }
    addCrossValidator(validator) {
        const instance = {
            validationArguments: this.property.propertiesAsList,
            validate: () => validator(this.property.properties)
        };
        this.property.addValidator(instance);
        return this;
    }
    defineVisibleIfAllMembersVisible() {
        this.defineVisibility(...this.property.propertiesAsList)((self, ...children) => children.every(child => child.isVisible()));
    }
    defineValidIfAllMembersValid(message) {
        this.addAsyncValidatorInternal(...this.property.propertiesAsList)((self, ...children) => __awaiter(this, void 0, void 0, function* () {
            yield Promise.all(children.map(child => child.validate()));
            const invalidChildren = children.filter(child => child.isValid());
            if (invalidChildren.length > 0) {
                return message(invalidChildren);
            }
        }));
    }
}
exports.GroupOfPropertiesRuleBuilder = GroupOfPropertiesRuleBuilder;
