import { PropertyScalar } from "../../properties/property-scalar";
import { AbstractProperty } from "../../properties/abstract-property";
import { PropertyDependencyOptions } from "../../dependency-graph/property-dependency";
import { PropertyScalarImpl } from "../../properties/property-scalar-impl";
import { Rule } from "../../rules/rule";
import { PropertyScalarValidator } from "../../validators/property-validator";
import { TextInterpreter, TextInterpreterFcn } from "../../util/text-interpreter/text-interpreter";
import { AsyncPropertyScalarValidator } from "../../validators/async-property-validator";
import { AbstractPropertyRuleBuilder } from "./abstract-property-rule-builder-impl";
export declare class PropertyScalarRuleBuilder<T> extends AbstractPropertyRuleBuilder<T, PropertyScalarImpl<T>> {
    private readonly notEmptyIfRequiredValidator;
    constructor(property: PropertyScalar<T>, notEmptyIfRequiredValidator: PropertyScalarValidator<unknown, []>, addDependencies: (from: readonly AbstractProperty[], to: AbstractProperty, options: PropertyDependencyOptions) => void, textInterpreters: {
        [textInterpreter in TextInterpreter]?: TextInterpreterFcn;
    });
    addValidator<Dependencies extends readonly AbstractProperty[]>(...dependencies: Dependencies): (validator: PropertyScalarValidator<T, Dependencies>) => PropertyScalarRuleBuilder<T>;
    addAsyncValidator<Dependencies extends readonly AbstractProperty[]>(...dependencies: Dependencies): (validator: AsyncPropertyScalarValidator<T, Dependencies>) => PropertyScalarRuleBuilder<T>;
    defineInitialValue(value: T): PropertyScalarRuleBuilder<T>;
    setRequiredIfVisible(required: boolean): PropertyScalarRuleBuilder<T>;
    defineRequiredIfVisible<Dependencies extends readonly AbstractProperty[]>(...dependencies: Dependencies): (required: Rule<[self: PropertyScalar<T>, ...dependencies: Dependencies], boolean>) => PropertyScalarRuleBuilder<T>;
    private defineRequiredIfVisibleFunction;
    defineLabelAndPlaceholder(text: string): PropertyScalarRuleBuilder<T>;
    definePlaceholder(placeholder: string): PropertyScalarRuleBuilder<T>;
    defineInfoText(text: string, textInterpreter?: TextInterpreter): PropertyScalarRuleBuilder<T>;
}
