"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SemanticRulesVersion = void 0;
const isSemanticVersion = /^(\d+)\.(\d+)\.(\d+)$/;
const SemanticRulesVersion = (major, minor, patch) => ({
    version: `${major}.${minor}.${patch}`,
    compatibleWith: version => {
        const match = isSemanticVersion.exec(version);
        if (match == null) {
            return false;
        }
        const majorOther = Number.parseInt(match[1]);
        const minorOther = Number.parseInt(match[2]);
        return major == majorOther && minor >= minorOther;
    }
});
exports.SemanticRulesVersion = SemanticRulesVersion;
