import { AbstractDataProperty } from "../properties/abstract-data-property";
import { AbstractProperty } from "../properties/abstract-property";
import { PropertyId } from "../properties/property-id";
import { CrossValidationResult } from "../validators/cross-validation-result";
import { CrossValidatorInstance } from "./validation/validator-instance-impl";
export interface RuleEngineUpdateHandler {
    needsAnUpdate(mightHaveChanged: AbstractProperty): void;
    updateValue(property: AbstractProperty): Promise<void> | undefined;
    cancelValidationAndInvalidateResults(validators: readonly CrossValidatorInstance<readonly AbstractProperty[]>[]): void;
    validateValidatorInstances(validators: readonly CrossValidatorInstance<readonly AbstractProperty[]>[]): Promise<CrossValidationResult | 'cancelled'>[];
    getPropertyById(id: PropertyId): AbstractDataProperty<unknown> | undefined;
    removeOwnedProperties(ownerId: PropertyId, ownedProperties?: PropertyId[]): void;
}
