import { AbstractDataProperty } from "./abstract-data-property";
import { AbstractProperty } from "./abstract-property";
export declare function isPropertyScalar(property: AbstractProperty): property is PropertyScalar<unknown>;
export interface PropertyScalar<D> extends AbstractDataProperty<D> {
    getInitialValue(): D | null;
    getDisplayValue(): string;
    awaitDisplayValue(): Promise<string>;
    setDisplayValue(value: string | null): void;
    getValue(): D | null;
    getNonNullValue(): D;
    awaitValue(): Promise<D | null>;
    setValue(value: D | null): void;
    isRequired(): boolean;
    isEmpty(): boolean;
    getInfoText(): string;
    getPlaceholder(): string;
}
