import { AbstractDataProperty } from "../properties/abstract-data-property";
import { AbstractProperty } from "../properties/abstract-property";
import { GroupOfProperties, PropertyGroup } from "../properties/group-of-properties";
import { ListOfProperties } from "../properties/list-of-properties";
import { PropertyArrayList } from "../properties/property-array-list";
import { PropertyScalar } from "../properties/property-scalar";
import { ValidationMessage } from "./validation-message";
export declare type AsyncPropertyValidator<T extends AbstractDataProperty<unknown>, Dependencies extends readonly AbstractProperty[]> = (property: T, ...dependencies: Dependencies) => Promise<ValidationMessage | void>;
export declare type AsyncPropertyScalarValidator<T, Dependencies extends readonly AbstractProperty[]> = AsyncPropertyValidator<PropertyScalar<T>, Dependencies>;
export declare type AsyncGroupOfPropertiesValidator<T extends PropertyGroup, Dependencies extends readonly AbstractProperty[]> = AsyncPropertyValidator<GroupOfProperties<T>, Dependencies>;
export declare type AsyncPropertyArrayListValidator<T, Dependencies extends readonly AbstractProperty[]> = AsyncPropertyValidator<PropertyArrayList<T>, Dependencies>;
export declare type AsyncListOfPropertiesValidator<T extends AbstractDataProperty<D>, D, Dependencies extends readonly AbstractProperty[]> = AsyncPropertyValidator<ListOfProperties<T, D>, Dependencies>;
