import { ValidationMessage } from "./validation-message";
import { ValidationType } from "./validation-type";
import { ValidationMessagesMap } from "./validation-messages-map";
import { PropertyId } from "../properties/property-id";
import { AbstractDataProperty } from "../properties/abstract-data-property";
export declare type ValidationMessageToString = (validationMessage: ValidationMessage, property: AbstractDataProperty<unknown>) => string;
export declare class ValidationResult {
    private readonly validationMessagesMap;
    private readonly getPropertyById;
    private valid?;
    constructor(validationMessagesMap: ValidationMessagesMap, getPropertyById: (id: PropertyId) => AbstractDataProperty<unknown>);
    getValidationMessagesMap(): ValidationMessagesMap;
    getAllMessages(): ValidationMessage[];
    getAllMessagesAsStrings(convert: ValidationMessageToString): string[];
    isValid(): boolean;
    filterByType(...types: ValidationType[]): ValidationResult;
    filterValid(): ValidationResult;
    filterInvalid(): ValidationResult;
    filterBy(fcn: (msg: ValidationMessage) => boolean): ValidationResult;
}
