import { PropertyGroup, GroupOfProperties, PropertyGroupData } from "./group-of-properties";
import { RuleEngineUpdateHandler } from "../engine/rule-engine-update-handler-impl";
import { AbstractDataProperty } from "./abstract-data-property";
import { AbstractProperty } from "./abstract-property";
import { AbstractParentPropertyImpl } from "./abstract-parent-property-impl";
export declare class GroupOfPropertiesImpl<T extends PropertyGroup> extends AbstractParentPropertyImpl<PropertyGroupData<T>> implements GroupOfProperties<T> {
    readonly id: string;
    readonly properties: T;
    readonly propertiesAsList: AbstractDataProperty<unknown>[];
    constructor(id: string, properties: T, updateHandler: RuleEngineUpdateHandler);
    protected getChildren(): AbstractProperty[];
    protected internallySyncUpdate(): void;
    protected internallyAsyncUpdate<V>(): {
        asyncPromise: Promise<V>;
        resolve: (value: V) => void;
    };
    isProcessing(): boolean;
    isReadOnly(): boolean;
    isAsynchronous(): boolean;
    setDataToInitialState(): void;
    exportData(): PropertyGroupData<T> | null;
    importData(data: PropertyGroupData<T> | null): void;
}
