var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export class DerivedAsyncValueProvider {
    constructor(dependencies, get, set) {
        this.dependencies = dependencies;
        this.get = get;
        this.set = set;
        this.processing = false;
    }
    getValue() {
        return __awaiter(this, void 0, void 0, function* () {
            this.processing = true;
            try {
                const result = yield this.get(this.dependencies);
                return result;
            }
            finally {
                this.processing = false;
            }
        });
    }
    setValue(value) {
        if (this.set) {
            return this.set(value, ...this.dependencies);
        }
    }
    isAsynchronous() {
        return true;
    }
    setDataToInitialState() {
        this.processing = false;
    }
    isProcessing() {
        return this.processing;
    }
    shouldBeCached() {
        return true;
    }
    isReadOnly() {
        return !this.set;
    }
}
