export class RulesDefinitionWithDependencies {
    constructor(dependencies, buildRulesFcn) {
        this.dependencies = dependencies;
        this.buildRulesFcn = buildRulesFcn;
    }
    buildRules(builder) {
        this.buildRulesFcn(builder, ...this.dependencies);
    }
}
export class RulesDefinitionComposition {
    constructor(definitions) {
        this.definitions = definitions;
    }
    buildRules(builder) {
        this.definitions.forEach(def => def.buildRules(builder));
    }
}
export class AbstractRulesDefinition {
    buildRules(builder) {
        if (!this.implementation) {
            throw new Error("No implementation provided");
        }
        this.implementation.buildRules(builder);
    }
    implementWith(implementation) {
        this.implementation = implementation;
    }
}
